--
-- DriveableRebelMoon
--
-- Author: Stijn Wopereis
-- Description: Specialization drivables for rebel moon
-- Name: DriveableRebelMoon
-- Hide: yes
--
-- Copyright (c) Creative Mesh, 2023

---@class DriveableRebelMoon
DriveableRebelMoon = {}
DriveableRebelMoon.MOD_NAME = g_currentModName

function DriveableRebelMoon.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Drivable, specializations)
end

function DriveableRebelMoon.registerOverwrittenFunctions(vehicleType)
    SpecializationUtil.registerOverwrittenFunction(vehicleType, "getSteeringDirection", DriveableRebelMoon.getSteeringDirection)
    SpecializationUtil.registerOverwrittenFunction(vehicleType, "getReverserDirection", DriveableRebelMoon.getReverserDirection)
end

function DriveableRebelMoon:getSteeringDirection(superFunc)
    if g_rebelMoon ~= nil then
        local factor = g_rebelMoon:getMovementFactor()
        return factor
    end

    return superFunc(self)
end

function DriveableRebelMoon:getReverserDirection(superFunc)
    if g_rebelMoon ~= nil then
        local factor = g_rebelMoon:getMovementFactor()
        self.spec_drivable.reverserDirection = factor

        return factor
    end

    return superFunc(self)
end
